-- phpMyAdmin SQL Dump
-- version 4.0.10deb1
-- http://www.phpmyadmin.net
--
-- Servidor: localhost
-- Tiempo de generación: 26-06-2015 a las 05:43:12
-- Versión del servidor: 5.5.43-0ubuntu0.14.04.1
-- Versión de PHP: 5.5.9-1ubuntu4.9

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Base de datos: `musicdb`
--
CREATE DATABASE IF NOT EXISTS `musicdb` DEFAULT CHARACTER SET latin1 COLLATE latin1_swedish_ci;
USE `musicdb`;

DELIMITER $$
--
-- Procedimientos
--
DROP PROCEDURE IF EXISTS `addAuthor`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addAuthor`(IN `nom` VARCHAR(50))
    MODIFIES SQL DATA
    COMMENT 'Per afegir un author a la base de dades'
BEGIN
	DECLARE exist TINYINT(1) DEFAULT NULL;
	SET exist = (SELECT 1 FROM author WHERE name = nom);
	IF (exist IS NULL)THEN
		INSERT INTO author(name) VALUES (nom);
		SELECT id FROM author WHERE name = nom;
		ELSE SELECT 0;
	END IF;
END$$

DROP PROCEDURE IF EXISTS `addAuthorPuntuation`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addAuthorPuntuation`(IN `songid` BIGINT, IN `authorid` BIGINT)
    MODIFIES SQL DATA
begin 
		declare p float;
		declare n_punt_autor bigint;

		set p = (select sum(puntuation) from puntuation where idaudio = songid);

		select count(iduser) into n_punt_autor
 		from puntuation
 		where iduser not  in (select p.iduser 
                  				from puntuation p inner join songauthor sa
                  				on p.idaudio = sa.idsong
                 				where sa.idauthor in (select idauthor from songauthor 
                                   					where idsong = songid)
                       			and idaudio != songid) 
		and idaudio = songid;

		update author a 
			set a.rating_total = a.rating_total + p,
				a.n_puntuations = a.n_puntuations + n_punt_autor
			where a.id = authorid;

end$$

DROP PROCEDURE IF EXISTS `addFav`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addFav`(IN `mid` BIGINT, IN `userid` BIGINT)
    MODIFIES SQL DATA
begin 
	declare n bigint;
	
	if(exists(select 1 from favorite where idmessage = mid and iduser = userid))THEN
		delete from favorite where idmessage = mid and iduser = userid;
		set n = (select count(idmessage)from favorite where idmessage = mid);
		select 0,n;
	
	else
	
		insert into favorite(idmessage,iduser) 
			values (mid,userid);
		set n = (select count(idmessage)from favorite where idmessage = mid);
		select 1,n;
	end if;

end$$

DROP PROCEDURE IF EXISTS `addGenre`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addGenre`(IN `gen` VARCHAR(20))
    NO SQL
BEGIN
	DECLARE exist TINYINT(1) DEFAULT NULL;
	SET exist = (SELECT 1 FROM genere WHERE name = gen);
	IF (exist IS NULL)THEN
		INSERT INTO genere(name) VALUES (gen);
		SELECT 1;
		ELSE SELECT 0;
	END IF;
END$$

DROP PROCEDURE IF EXISTS `addMessage`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addMessage`(IN `txt` VARCHAR(1000), IN `userid` BIGINT, IN `ansid` BIGINT)
    MODIFIES SQL DATA
BEGIN

	if(ansid < 0)then
		set ansid = null;
	end if;
	INSERT INTO message(iduser,idanswer,text)
		VALUES (userid,ansid,txt);


	select 1,LAST_INSERT_ID();

END$$

DROP PROCEDURE IF EXISTS `addOrUpdateSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addOrUpdateSong`(IN `nom` VARCHAR(50), IN `song` MEDIUMBLOB, IN `dat` DATE, IN `ext` VARCHAR(4), IN `songid` BIGINT, IN `userid` BIGINT, IN `license` INT(3))
    MODIFIES SQL DATA
BEGIN
    declare userOwnsSong TINYINT(1);
	declare id BIGINT;
	
	
		IF (songid = -1)THEN
			/*
				CANSO NOVA
				INSERTAR A AUDIO
				INSERTAR A USER-SONG
			*/
			IF(not exists(select 1 from songuser su 
                          inner join audio a on su.idsong = a.idaudio 
                          where su.iduser = userid and a.name = nom))THEN
	
				INSERT INTO audio(name,extension,data,date,idlicense) 
					VALUES (nom,ext,song,dat,license);
			
		
				set id = LAST_INSERT_ID();
			
				INSERT INTO songuser(idsong,iduser)
					VALUES (id, userid);
		
				SELECT 1,id;
			ELSE
				select 2,songid;
			end if;
  	  	
		ELSE
			/*
				NO ES NOVA
				COMPROVAR QUE L'HAGI PENJADA ELL
			*/
			SET userOwnsSong = (SELECT 1 FROM songuser 
    	                    where iduser = userid and idsong = songid);
		
			/*
				SI ES UN DELS AUTORS
				UPDATE DE LA CANSO
			*/
			IF(userOwnsSong = 1)THEN
				UPDATE audio
				SET name = nom,
					extension = ext,
				data = song,
				date = dat,
				idlicense = license
				where idaudio = songid;
				SELECT 1,songid;
		
			else
				SELECT 0,songid;
			end if;
		end if;

	
	
	
	
END$$

DROP PROCEDURE IF EXISTS `addSongAuthorRelation`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addSongAuthorRelation`(IN `autor` VARCHAR(50), IN `song` BIGINT, IN `userid` BIGINT)
    MODIFIES SQL DATA
    COMMENT 'Els autors han d''existir'
BEGIN
    DECLARE ida BIGINT;
	DECLARE alreadyExists TINYINT(1);
	
    SET ida = (select id FROM author WHERE name = autor);

	IF (ida IS NOT NULL) THEN
		SET alreadyExists = (exists(select 1 from songauthor where idsong = song and idauthor = ida ));
	
		
		IF(!alreadyExists)THEN
			INSERT INTO songauthor(idsong,idauthor) VALUES (song,ida);	
		END IF;

		SELECT 1;

	ELSE
		SELECT 0;
	END IF;
	

END$$

DROP PROCEDURE IF EXISTS `addSongDisk`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addSongDisk`(IN `songid` BIGINT, IN `diskid` BIGINT, IN `user` BIGINT, IN `pos` INT)
    MODIFIES SQL DATA
BEGIN
   
	

	IF(not exists(select 1 from songdisk where idsong = songid and iddisk = diskid)
      and
      exists(SELECT 1 FROM songuser 
                        where iduser = user and idsong = songid))THEN
/* si no existeix la relacio song-disk i ell ha penjat la cançó */
		INSERT INTO songdisk(idsong,iddisk,position) VALUES (songid,diskid,pos);	
		
		select 1;
	else 
		select 0;
	END IF;
	

END$$

DROP PROCEDURE IF EXISTS `addSongGenreRelation`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addSongGenreRelation`(IN `gen` VARCHAR(20), IN `song` BIGINT, IN `userid` BIGINT)
    MODIFIES SQL DATA
BEGIN
    DECLARE idg BIGINT;
	DECLARE alreadyExists TINYINT(1);
	
    SET idg = (select id FROM genere WHERE name = gen);
	
	IF (idg IS NOT NULL) THEN
		SET alreadyExists = (exists(select 1 from songgenere where idsong = song and idgenere = idg ));
		
		IF(!alreadyExists)THEN
			INSERT INTO songgenere(idsong,idgenere) VALUES (song,idg);				
		END IF;

		SELECT 1;
	ELSE
		SELECT 0;
	END IF;

END$$

DROP PROCEDURE IF EXISTS `addUser`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `addUser`(IN `ml` VARCHAR(50), IN `pass` VARCHAR(50), IN `tok` VARCHAR(33))
    MODIFIES SQL DATA
    DETERMINISTIC
    COMMENT 'Per registrar un usuari a la base de dades'
BEGIN
  DECLARE idu BIGINT;
  declare i bigint default 0;
  declare temp_name varchar(50);
	IF(NOT exists(select 1 from user where email = ml))THEN
		SELECT `auto_increment`INTO idu FROM INFORMATION_SCHEMA.TABLES
		WHERE table_name = 'author' limit 1;
		set i = idu;
		set temp_name = concat('user_',i);
		while (select exists(select 1 from author where name = temp_name and id != idu))DO
			set i = i + 1;
			set temp_name = concat('user_',i);
		END WHILE;
		INSERT INTO author(name) VALUES (temp_name);

		SELECT last_insert_id() INTO idu;
		

		INSERT INTO user(iduser,email,password,isVerified) VALUES (idu,ml,SHA(pass),False);
    	
		INSERT INTO token(token,iduser) VALUES (tok,idu);
		UPDATE token SET expirationDate = TIMESTAMPADD(DAY,1,CURRENT_TIMESTAMP) 
			WHERE iduser = idu;
		SELECT idu;
	ELSE
		select -1;
	END if;
END$$

DROP PROCEDURE IF EXISTS `canLogin`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `canLogin`(IN `mail` VARCHAR(50), IN `pass` VARCHAR(50))
begin
SELECT u.password,u.iduser,u.isVerified ,a.name
FROM user u inner join author a on u.iduser = a.id
WHERE u.email = mail and u.password = SHA(pass);

end$$

DROP PROCEDURE IF EXISTS `changePassword`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `changePassword`(IN `pass` VARCHAR(50), IN `tok` VARCHAR(33), IN `ma` VARCHAR(50))
    NO SQL
BEGIN
	DECLARE idus BIGINT(20) DEFAULT -1;
	DECLARE toktemp VARCHAR(33) DEFAULT 'empty';
	DECLARE mailValid TINYINT(1);
	SET idus = (SELECT u.iduser FROM user u where u.email = ma);
	SET toktemp = (SELECT t.token FROM token t WHERE t.iduser = idus);
	SET mailValid = (select now() < expirationDate from token where iduser = idus AND token = tok);
	if (toktemp not like 'empty' AND mailValid) THEN
    	UPDATE user u SET u.password = SHA(pass) WHERE u.email = ma;
	END IF;
	if (mailValid is NULL) THEN
		SET mailValid = -3;
	END IF;
	SELECT mailValid;
	
END$$

DROP PROCEDURE IF EXISTS `deleteAuthorsAndGenresOfSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `deleteAuthorsAndGenresOfSong`(IN `song` BIGINT)
    MODIFIES SQL DATA
BEGIN
DELETE FROM songauthor
	where idsong = song;
DELETE FROM songgenere
	where idsong = song;
	
END$$

DROP PROCEDURE IF EXISTS `deleteAuthorsPuntuation`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `deleteAuthorsPuntuation`(IN `songid` BIGINT)
    MODIFIES SQL DATA
begin
		declare p float;
		declare n_punt_autor bigint;

		set p = (select sum(puntuation) from puntuation where idaudio = songid);
		select count(iduser) into n_punt_autor
 							from puntuation
 							where iduser not  in (select p.iduser 
                  									from puntuation p inner join songauthor sa
                  									on p.idaudio = sa.idsong
                 									 where sa.idauthor in (select idauthor from songauthor 
                                   									   		where idsong = songid)
                       								and idaudio != songid) 
							and idaudio = songid;
		update author a inner join songauthor sa on a.id = sa.idauthor
			set a.rating_total = a.rating_total - p,
				a.n_puntuations = a.n_puntuations - n_punt_autor
			where sa.idsong = songid;
end$$

DROP PROCEDURE IF EXISTS `deleteDisk`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `deleteDisk`(IN `diskid` BIGINT, IN `userid` BIGINT)
    MODIFIES SQL DATA
BEGIN

	IF(exists(select 1 
                  from diskuser du
                  where du.iddisk = diskid and du.iduser = userid))THEN
		delete from disk where id = diskid;
		update audio 
			set diskimage = null
			where diskimage = diskid;
		select 1;
	else 
		select 0;
	END IF;

END$$

DROP PROCEDURE IF EXISTS `deleteDiskImage`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `deleteDiskImage`(IN `songid` BIGINT)
    MODIFIES SQL DATA
update audio
	set diskimage = NULL,songimage = 1
	where idaudio = songid$$

DROP PROCEDURE IF EXISTS `deleteDiskSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `deleteDiskSong`(IN `diskid` BIGINT, IN `songid` BIGINT)
    MODIFIES SQL DATA
BEGIN

	DELETE from songdisk
		where idsong = songid and iddisk = diskid;
END$$

DROP PROCEDURE IF EXISTS `deleteSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `deleteSong`(IN `songid` BIGINT, IN `user` BIGINT)
    MODIFIES SQL DATA
BEGIN
	if(exists(select 1 from songuser where iduser = user and idsong = songid))THEN
	DELETE FROM audio WHERE idaudio =  songid;

	DELETE FROM songuser WHERE idsong = songid;
	DELETE FROM songauthor WHERE idsong = songid;
	DELETE FROM songgenere WHERE idsong = songid;
	DELETE FROM songdisk WHERE idsong = songid;

	DELETE FROM historic WHERE idsong = songid;
	

	DELETE FROM puntuation WHERE idaudio = songid;
	DELETE FROM similituds WHERE idsong1 = songid OR idsong2 = songid;
	select 1;
	ELSE
	select 0;
	END if;
END$$

DROP PROCEDURE IF EXISTS `deleteSongsOfDisk`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `deleteSongsOfDisk`(IN `diskid` BIGINT)
    MODIFIES SQL DATA
BEGIN

	DELETE from songdisk
		where iddisk = diskid;
END$$

DROP PROCEDURE IF EXISTS `editMessage`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `editMessage`(IN `mid` BIGINT, IN `userid` BIGINT, IN `missatge` VARCHAR(1000))
    MODIFIES SQL DATA
BEGIN
	IF(EXISTS(select 1  from message where idmessage = mid and iduser = userid))THEN
       update message 
			set text = missatge
       		where idmessage = mid and iduser = userid;
       select 1;
    ELSE
       select 0;
    END IF;
END$$

DROP PROCEDURE IF EXISTS `existsSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `existsSong`(IN `songid` BIGINT)
    READS SQL DATA
BEGIN
	IF (SELECT 1 FROM audio WHERE idaudio = songid)THEN
		SELECT 1;
	ELSE
		SELECT 0;
	END IF;

END$$

DROP PROCEDURE IF EXISTS `getAuthorInfo`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getAuthorInfo`(IN `autid` BIGINT)
    READS SQL DATA
select name, description,web from author where id = autid$$

DROP PROCEDURE IF EXISTS `getAuthorName`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getAuthorName`(IN `input` VARCHAR(50))
    READS SQL DATA
BEGIN

    SELECT a.name,a.id FROM author a  WHERE a.name LIKE CONCAT('%',input,'%') 
		and CHAR_LENGTH(a.name) > 0
	order by a.name;

END$$

DROP PROCEDURE IF EXISTS `getAuthorsIDSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getAuthorsIDSong`(IN `songid` BIGINT)
    MODIFIES SQL DATA
BEGIN
	SELECT su.iduser 
		from  songuser su
		where su.idsong = songid;
END$$

DROP PROCEDURE IF EXISTS `getAuthorsSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getAuthorsSong`(IN `songid` BIGINT)
    NO SQL
BEGIN
	SELECT aut.name , aut.id
		from author aut inner join songauthor sa
			on aut.id = sa.idauthor
		where sa.idsong = songid AND CHAR_LENGTH(aut.name) > 0;
END$$

DROP PROCEDURE IF EXISTS `getDiskInfo`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getDiskInfo`(IN `user` BIGINT, IN `diskname` VARCHAR(50))
    READS SQL DATA
BEGIN
	select d.id,d.release_date
from  disk d inner join diskuser du on d.id = du.iddisk
where du.iduser = user and d.name = diskname

;


END$$

DROP PROCEDURE IF EXISTS `getDiskName`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getDiskName`(IN `diskid` BIGINT)
BEGIN
	select name from disk where id = diskid;
END$$

DROP PROCEDURE IF EXISTS `getDisksAuthor`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getDisksAuthor`(IN `aut` BIGINT)
BEGIN

    SELECT d.id,d.name
	FROM disk d inner join diskuser du on d.id = du.iddisk
	where du.iduser = aut;

END$$

DROP PROCEDURE IF EXISTS `getDisksOfSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getDisksOfSong`(IN `songid` BIGINT)
    READS SQL DATA
BEGIN
	select d.name,d.id
from  songdisk sg inner join disk d on sg.iddisk = d.id


where  sg.idsong = songid

;


END$$

DROP PROCEDURE IF EXISTS `getFavorites`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getFavorites`(IN `messageid` BIGINT)
    READS SQL DATA
select count(idmessage) from favorite where idmessage = messageid$$

DROP PROCEDURE IF EXISTS `getFirstDiskOfSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getFirstDiskOfSong`(IN `song` BIGINT)
    READS SQL DATA
select iduser
	from songuser
	where idsong = song	
	limit 1$$

DROP PROCEDURE IF EXISTS `getGenres`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getGenres`(IN `input` VARCHAR(50))
    READS SQL DATA
BEGIN
	SELECT name FROM genere WHERE name LIKE CONCAT('%',input,'%');

END$$

DROP PROCEDURE IF EXISTS `getGenresSong`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getGenresSong`(IN `songid` BIGINT)
BEGIN
	SELECT g.name 
		from genere g inner join songgenere sg
			on g.id = sg.idgenere
		where sg.idsong = songid
		order by g.name;
END$$

DROP PROCEDURE IF EXISTS `getGenresSongs`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getGenresSongs`()
    READS SQL DATA
select distinct sg.idgenere, g.name 
	from songgenere sg inner join genere g
	on sg.idgenere = g.id
order by g.name$$

DROP PROCEDURE IF EXISTS `getMessages`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getMessages`(IN `ind` BIGINT, IN `n` TINYINT, IN `user` BIGINT)
BEGIN
	if(user = -1)THEN
	
	
		if((SELECT exists(select 1 	from message m 	where m.idanswer is null
				order by m.idmessage desc 	limit ind,1)))THEN
	
			(SELECT m.text,m.iduser, a.name, m.idanswer,m.idmessage
			from message m inner join author a 
				on m.iduser = a.id
			where m.idanswer is null
			order by m.idmessage desc
			limit ind,n)
		
			union
		
			(SELECT m.text,m.iduser, a.name, m.idanswer,m.idmessage
			from message m inner join author a 
				on m.iduser = a.id 
			where m.idanswer in  (select * from (SELECT m2.idmessage
								from message m2 
								where m2.idanswer is null
                                 order by m2.idmessage desc
								limit ind,n) as t)
			order by m.idmessage desc);
		else
			select null,null,null,null,null;
		end if;
	else
		if((SELECT exists(select 1 	from message m 	where m.idanswer is null and m.iduser = user
			order by m.idmessage desc 	limit ind,1)))THEN

			(SELECT m.text,m.iduser, a.name, m.idanswer,m.idmessage
			from message m inner join author a 
				on m.iduser = a.id
			where m.idanswer is null and m.iduser = user
			order by m.idmessage desc
			limit ind,n)
		
			union
		
			(SELECT m.text,m.iduser, a.name, m.idanswer,m.idmessage
			from message m inner join author a 
				on m.iduser = a.id 
			where m.idanswer in  (select * from (SELECT m2.idmessage
								from message m2 
								where m2.idanswer is null and m2.iduser = user
                                 limit ind,n)as t)
			order by m.idmessage desc);
		else
			select null,null,null,null,null;
		end if;
	end if;
	
	
	
END$$

DROP PROCEDURE IF EXISTS `getMyDiskNames`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getMyDiskNames`(IN `input` VARCHAR(50), IN `user` BIGINT)
    READS SQL DATA
BEGIN

    SELECT d.id,d.name 
	FROM disk d INNER JOIN diskuser du ON d.id = du.iddisk
	WHERE name LIKE CONCAT('%',input,'%')
			AND user = du.iduser;

END$$

DROP PROCEDURE IF EXISTS `getMyDisks`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getMyDisks`(IN `user` BIGINT)
    READS SQL DATA
BEGIN

    SELECT d.id,d.name ,d.release_date
	FROM disk d INNER JOIN diskuser du ON d.id = du.iddisk
	WHERE  user = du.iduser;

END$$

DROP PROCEDURE IF EXISTS `getMyFav`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getMyFav`(IN `messageid` BIGINT, IN `userid` BIGINT)
    READS SQL DATA
select exists(select 1 from favorite where idmessage = messageid and iduser = userid)$$

DROP PROCEDURE IF EXISTS `getMyPuntuations`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getMyPuntuations`(IN `user` BIGINT)
    READS SQL DATA
BEGIN

	SELECT idaudio, puntuation from puntuation where iduser = user order by puntuation DESC;
END$$

DROP PROCEDURE IF EXISTS `getMyPuntuationsGenre`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getMyPuntuationsGenre`(IN `user` BIGINT, IN `gen` BIGINT)
    READS SQL DATA
BEGIN

	SELECT p.idaudio, p.puntuation 
from puntuation p inner join songgenere sg
on p.idaudio = sg.idsong
where p.iduser = user AND sg.idgenere = gen
order by p.puntuation DESC;
END$$

DROP PROCEDURE IF EXISTS `getRandomSongNotRecently`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getRandomSongNotRecently`(IN `user` BIGINT)
    READS SQL DATA
BEGIN
DECLARE mx bigint;
declare mn bigint;
declare song bigint;
declare num bigint;

set mx = (SELECT MAX(idaudio) FROM audio);
set mn = (SELECT Min(idaudio) FROM audio);
set num = (SELECT count(idaudio) FROM audio);

IF((select count(idsong) from historic where iduser = user) = num)THEN
	/*RANDOM*/
	set song = (SELECT idaudio 

	FROM audio a,

	(SELECT ROUND((RAND() * (mx-mn))+mn) AS id) AS x 

	WHERE a.idaudio >= x.id

	LIMIT 1);
	
ELSE
	/*RANDOM NOT RECENTLY LISTENED*/
	set song = (SELECT idaudio 

	FROM audio a,

	(SELECT ROUND((RAND() * (mx-mn))+mn) AS id) AS x 

	WHERE (a.idaudio >= x.id or a.idaudio < x.id)
	AND a.idaudio NOT IN (SELECT idsong from historic where iduser = user)
	LIMIT 1);

END IF;
select song;

END$$

DROP PROCEDURE IF EXISTS `getRandomSongNotRecentlyGenre`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getRandomSongNotRecentlyGenre`(IN `user` BIGINT, IN `gen` BIGINT)
    READS SQL DATA
BEGIN
DECLARE mx bigint;
declare mn bigint;
declare song bigint;
declare num bigint;
declare r int;


set num = (SELECT count(idsong) FROM songgenere  where idgenere = gen);

IF((select count(h.idsong) from historic h  inner join songgenere sg on h.idsong = sg.idsong where h.iduser = user AND sg.idgenere = gen) = num)THEN
	/*RANDOM*/
	set mx = (SELECT MAX(idsong) FROM songgenere where idgenere = gen);
	set mn = (SELECT Min(idsong) FROM songgenere where idgenere = gen);

	set song = (SELECT idsong 

	FROM  songgenere,

	(SELECT ROUND((RAND() * (mx-mn))+mn) AS id) AS x 
	WHERE idgenere = gen and idsong >= x.id limit 1

	);

ELSE

	set mx = (SELECT MAX(sg.idsong) FROM songgenere sg  where sg.idgenere = gen and sg.idsong not in (select idsong from historic));
	set mn = (SELECT MIN(sg.idsong) FROM songgenere sg  where sg.idgenere = gen and sg.idsong not in (select idsong from historic));
	/*RANDOM NOT RECENTLY LISTENED*/
	set song = (SELECT idsong 

	FROM  songgenere,

	(SELECT ROUND((RAND() * (mx-mn))+mn) AS id) AS x 

	WHERE idsong >= x.id 
	AND idsong NOT IN (SELECT idsong from historic where iduser = user)
                AND idgenere = gen
	LIMIT 1);
	
END IF;
select song;

END$$

DROP PROCEDURE IF EXISTS `getSinglesAuthor`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getSinglesAuthor`(IN `aut` BIGINT)
BEGIN
	SELECT a.idaudio, a.name, (a.rating_total/a.n_puntuations) as points, a.diskimage
	from songauthor sa 	inner join audio a on a.idaudio = sa.idsong
	where sa.idauthor = aut
	order by points DESC, a.n_puntuations DESC;
END$$

DROP PROCEDURE IF EXISTS `getSongName`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getSongName`(IN `input` VARCHAR(50), IN `user` BIGINT)
    READS SQL DATA
BEGIN

    SELECT distinct a.name,a.idaudio 
	FROM audio a INNER JOIN songuser su ON a.idaudio = su.idsong
	WHERE a.name LIKE CONCAT('%',input,'%')
		AND su.iduser = user
	order by a.name;

END$$

DROP PROCEDURE IF EXISTS `getSongsNotPuntuatedNotListened`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getSongsNotPuntuatedNotListened`(IN `user` BIGINT, IN `punt` FLOAT)
    READS SQL DATA
BEGIN
select s.idsong1 as 'Not voted' ,s.idsong2 as 'Voted' ,s.simil
	from  similituds s 	INNER join puntuation p on s.idsong2 = p.idaudio
	where  
s.idsong1 not in (select idsong from historic where iduser = user) and 
s.idsong2 not in (select idsong from historic where iduser = user) and
p.iduser = user and
s.idsong1 not in (select idaudio from puntuation where iduser = user)
and p.puntuation >= punt

UNION

select s.idsong2 as 'Not voted' ,s.idsong1 as 'Voted' ,s.simil
	from  similituds s 	INNER join puntuation p on s.idsong1 = p.idaudio
	where   
s.idsong1 not in (select idsong from historic where iduser = user) and 
s.idsong2 not in (select idsong from historic where iduser = user) and
p.iduser = user and
s.idsong2 not in (select idaudio from puntuation where iduser = user)
and p.puntuation >= punt;

END$$

DROP PROCEDURE IF EXISTS `getSongsNotPuntuatedNotListenedGenre`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getSongsNotPuntuatedNotListenedGenre`(IN `user` BIGINT, IN `gen` BIGINT, IN `punt` FLOAT)
    READS SQL DATA
BEGIN
select s.idsong1 as 'Not voted' ,s.idsong2 as 'Voted' ,s.simil
	from  similituds s 	INNER join puntuation p on s.idsong2 = p.idaudio
	where  
s.idsong1  in (select idsong from songgenere where idgenere = gen) and 
s.idsong2 in (select idsong from songgenere where idgenere = gen) and 
s.idsong1 not in (select idsong from historic where iduser = user) and 
s.idsong2 not in (select idsong from historic where iduser = user) and
p.iduser = user and
s.idsong1 not in (select idaudio from puntuation where iduser = user)
and p.puntuation >= punt

UNION

select s.idsong2 as 'Not voted' ,s.idsong1 as 'Voted' ,s.simil
	from  similituds s 	INNER join puntuation p on s.idsong1 = p.idaudio
	where  
s.idsong1  in (select idsong from songgenere where idgenere = gen) and 
s.idsong2 in (select idsong from songgenere where idgenere = gen) and 
s.idsong1 not in (select idsong from historic where iduser = user) and 
s.idsong2 not in (select idsong from historic where iduser = user) and
p.iduser = user and
s.idsong2 not in (select idaudio from puntuation where iduser = user)
and p.puntuation >= punt;

END$$

DROP PROCEDURE IF EXISTS `getSongsNotRecentlyListenedThres`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getSongsNotRecentlyListenedThres`(IN `user` BIGINT, IN `thres` FLOAT)
    READS SQL DATA
BEGIN



	SELECT idaudio 
from puntuation 
where iduser = user AND idaudio not in (select idsong from historic where iduser = user)
		AND puntuation >= thres
order by puntuation DESC
LIMIT 50;

END$$

DROP PROCEDURE IF EXISTS `getSongsNotRecentlyListenedThresGnere`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getSongsNotRecentlyListenedThresGnere`(IN `user` BIGINT, IN `thres` FLOAT, IN `gen` BIGINT)
    READS SQL DATA
    COMMENT 'Cançons puntuades no recentment amb puntuació major que ''thres'''
BEGIN



	SELECT p.idaudio 
from puntuation p inner join songgenere sg on p.idaudio = sg.idsong
where iduser = user AND idaudio not in (select idsong from historic where iduser = user)
		AND p.puntuation >= thres
		AND sg.idgenere = gen
order by p.puntuation DESC
LIMIT 50;

END$$

DROP PROCEDURE IF EXISTS `getSongsOfDisk`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getSongsOfDisk`(IN `diskid` BIGINT)
    READS SQL DATA
BEGIN
	select idsong 
from  songdisk 


where  iddisk = diskid

;


END$$

DROP PROCEDURE IF EXISTS `getSongsOfDiskComplete`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getSongsOfDiskComplete`(IN `diskid` BIGINT)
    READS SQL DATA
BEGIN

    SELECT a.idaudio, a.name, (a.rating_total/a.n_puntuations) as points
	FROM audio a inner join songdisk sd on a.idaudio = sd.idsong
	WHERE sd.iddisk = diskid
	ORDER BY sd.position;

END$$

DROP PROCEDURE IF EXISTS `getSongsUser`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getSongsUser`(IN `userid` BIGINT)
    READS SQL DATA
BEGIN
	SELECT a.idaudio,a.name, a.date ,a.extension,a.diskimage,a.idlicense
		from audio a inner join songuser su
			on a.idaudio = su.idsong
	where su.iduser = userid;
END$$

DROP PROCEDURE IF EXISTS `getUrlUser`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `getUrlUser`(IN `id` BIGINT)
    READS SQL DATA
select url_image from user where iduser = id$$

DROP PROCEDURE IF EXISTS `ownsDisk`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `ownsDisk`(IN `user` BIGINT, IN `id` BIGINT)
BEGIN
	select d.release_date
from  disk d inner join diskuser du on d.id = du.iddisk
where du.iduser = user and d.id = id

;


END$$

DROP PROCEDURE IF EXISTS `removeAllPuntuations`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `removeAllPuntuations`()
    READS SQL DATA
BEGIN
delete from puntuation where 1;
update audio a,disk d,author au
	set a.rating_total = 0, a.n_puntuations = 0,
		d.rating_total = 0, d.n_puntuations = 0,
	  au.rating_total = 0, au.n_puntuations = 0;
END$$

DROP PROCEDURE IF EXISTS `removeInconsistentSongs`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `removeInconsistentSongs`()
    MODIFIES SQL DATA
    COMMENT 'utilitzar nomes desde phpmyadmin quan s''elimini una canço'
Begin
	delete from songgenere
		where idsong not in (select idaudio from audio);
delete from songauthor
		where idsong not in (select idaudio from audio);
delete from songdisk
		where idsong not in (select idaudio from audio);
delete from puntuation
		where idaudio not in (select idaudio from audio);
delete from songuser
		where idsong not in (select idaudio from audio);
delete from audio
		where idaudio not in (select idsong from songuser);
end$$

DROP PROCEDURE IF EXISTS `removeMessage`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `removeMessage`(IN `mid` BIGINT, IN `userid` BIGINT)
    MODIFIES SQL DATA
BEGIN
	IF(EXISTS(select 1  from message where idmessage = mid and iduser = userid))THEN
       delete from message 
       		where idmessage = mid and iduser = userid;
       select 1;
    ELSE
       select 0;
    END IF;
END$$

DROP PROCEDURE IF EXISTS `search`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `search`(IN `text` VARCHAR(50))
    READS SQL DATA
(select idaudio,name, "0"
	from audio
	where name like concat("%",text,'%'))

UNION all

(select id,name,"2"
	from author
	where name like concat('%',text,'%'))

UNION all

(select distinct d.id, d.name,"1"
	from disk d inner join songdisk sd on d.id = sd.iddisk
	where name like concat('%',text,'%'))$$

DROP PROCEDURE IF EXISTS `updateAlbumPuntuation`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `updateAlbumPuntuation`(IN `album` BIGINT)
    MODIFIES SQL DATA
begin
	declare p float;
	declare n bigint;


		select sum(puntuation), count(distinct iduser) into p,n 
                 from puntuation 
				  where idaudio in (select idsong from songdisk where iddisk = album) 
                 ;
                
		
		
		update disk d 
			set d.rating_total = p,
				d.n_puntuations = n
			where d.id = album;
		
end$$

DROP PROCEDURE IF EXISTS `updateDisk`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `updateDisk`(IN `diskname` VARCHAR(50), IN `user` BIGINT, IN `dat` DATE, IN `tempdiskid` BIGINT)
    MODIFIES SQL DATA
BEGIN
	DECLARE diskid BIGINT;
	declare existUserDisk TINYINT(1);

	if(tempdiskid = -1)THEN
		SET diskid = (SELECT d.id 
		FROM disk d INNER JOIN diskuser du ON d.id = du.iddisk
		where d.name = diskname AND du.iduser = user);

	
		INSERT INTO disk(name,release_date) VALUES (diskname,dat);
		SET diskid = LAST_INSERT_ID();
	else
		set diskid = tempdiskid;
	END IF;
	
	
	set existUserDisk = (select 1 from diskuser 
                         where iduser = user and iddisk = diskid);

	
	IF (existUserDisk IS NULL)then
		
		IF(!exists(select 1 from diskuser where iddisk = diskid))then
			insert into diskuser(iduser,iddisk) values
			(user,diskid);
		end if;
	elseif (existUserDisk IS NOT NULL) THEN 
		UPDATE disk
		SET name = diskname,
			release_date = dat
		WHERE id = diskid;
	end if;
	select diskid;
	
	
	

END$$

DROP PROCEDURE IF EXISTS `updateFacebookLogin`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `updateFacebookLogin`(IN `fib` BIGINT, IN `mail` VARCHAR(50), IN `nom` VARCHAR(50), IN `url` VARCHAR(100))
    MODIFIES SQL DATA
begin
	declare correu varchar(50);
	declare user_name varchar(50);
	declare face bigint;
	declare idu bigint;
	declare temp_name varchar(50);
	declare i bigint default 0;

	select u.email, u.facebook_id, a.name,u.iduser into correu,face,user_name,idu
		from user u inner join author a on u.iduser = a.id
		where u.email = mail;
	
	if(face != 0)THEN/* already registered */
		select idu,user_name;
	ELSE
		set temp_name = nom;
		while (select exists(select 1 from author where name = temp_name and id != idu))DO
			set temp_name = concat(nom,'_',i);
			set i = i + 1;
		END WHILE;

		IF(face is null)THEN
			/* user does not exists in database */
			/* new user */
			SELECT `auto_increment`INTO idu FROM INFORMATION_SCHEMA.TABLES
				WHERE table_name = 'author';
			
			INSERT INTO author(name) VALUES (temp_name);
			INSERT INTO user(iduser,email,isVerified,url_image) VALUES (idu,mail,True,url);
		ELSE /* face == 0, update existing user */
			update user
				set facebook_id = fib,
				url_image = url
				where iduser = idu;
			update author
				set name = temp_name
				where id = idu;
		END IF;
		select idu,temp_name;
		
	END IF;
end$$

DROP PROCEDURE IF EXISTS `updatePuntuation`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `updatePuntuation`(IN `userid` BIGINT, IN `songid` BIGINT, IN `p` FLOAT)
    MODIFIES SQL DATA
BEGIN
	DECLARE antp FLOAT;
	
	set antp = (select puntuation 
                      from puntuation 
                      where idaudio = songid and iduser = userid);


	if(antp is null)THEN
		set antp = 0;
		insert into puntuation(idaudio,iduser,puntuation)
			values (songid,userid,p);
	else
		update puntuation 
			set puntuation = p
			where idaudio = songid and iduser = userid;

	END if;

	if(antp = 0)then
		update audio
			set n_puntuations = n_puntuations +  1, rating_total = rating_total + p 
			where idaudio = songid;
	
		update author a
			inner join songauthor sa on a.id = sa.idauthor
			set a.n_puntuations = a.n_puntuations +  1, a.rating_total = a.rating_total + p 
			where sa.idsong = songid;
	
		update disk d
			inner join songdisk sd on d.id = sd.iddisk
			set d.n_puntuations = d.n_puntuations +  1, d.rating_total = d.rating_total + p 
			where sd.idsong = songid;
	
			
	ELSE
		update audio
			set  rating_total = rating_total + p - antp 
			where idaudio = songid;

		update author a
			inner join songauthor sa on a.id = sa.idauthor
			set  a.rating_total = a.rating_total + p - antp 
			where sa.idsong = songid;

		update disk d
			inner join songdisk sd on d.id = sd.iddisk
			set d.rating_total = d.rating_total + p -antp
			where sd.idsong = songid;
	END if;
	select 1;
	

END$$

DROP PROCEDURE IF EXISTS `updateSongDiskimage`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `updateSongDiskimage`(IN `songid` BIGINT, IN `diskid` BIGINT, IN `userid` BIGINT)
    MODIFIES SQL DATA
BEGIN
	DECLARE disk BIGINT;
	SET disk = (select iddisk from diskuser where iddisk = diskid and iduser = userid );
	IF(disk IS NOT NULL and exists(select 1 from songdisk where idsong = songid and iddisk = diskid))THEN
		update audio
			set diskimage = disk, songimage = 0
			where idaudio = songid;
		select 1;
	ELSE
		select 0;
	END IF;
END$$

DROP PROCEDURE IF EXISTS `updateSongWithoutBinary`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `updateSongWithoutBinary`(IN `nom` VARCHAR(50), IN `dat` DATE, IN `songid` BIGINT, IN `userid` BIGINT, IN `license` INT(3))
    MODIFIES SQL DATA
BEGIN
    declare userOwnsSong TINYINT(1);

	

	
		/*
			NO ES NOVA
			COMPROVAR QUE SIGUI UN DELS AUTORS DE LA CANSO
		*/
		SET userOwnsSong = (SELECT 1 FROM songuser 
                        where iduser = userid and idsong = songid);
		
		/*
			SI L'HA PENJADA ELL
				UPDATE DE LA CANSO
		*/
		IF(userOwnsSong = 1)THEN
			UPDATE audio
			SET name = nom,
				date = dat,
				idlicense = license
			where idaudio = songid;
			SELECT 1,songid;
		ELSE
			SELECT 0,songid;
		end if;
		
	
	
	
	
END$$

DROP PROCEDURE IF EXISTS `updateToken`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `updateToken`(IN `tok` VARCHAR(33), IN `ma` VARCHAR(50))
    NO SQL
BEGIN
	DECLARE idus BIGINT(20) DEFAULT -1;
	SET idus = (SELECT u.iduser FROM user u where u.email = ma);
	if (idus != -1) THEN
    	UPDATE token t SET t.token = tok,expirationDate = TIMESTAMPADD(HOUR,1,CURRENT_TIMESTAMP)
			WHERE t.iduser = idus;
	END IF;
END$$

DROP PROCEDURE IF EXISTS `updateTokenGetUser`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `updateTokenGetUser`(IN `tok` VARCHAR(33), IN `ma` VARCHAR(50), IN `pass` VARCHAR(50))
    READS SQL DATA
BEGIN
	DECLARE idus BIGINT(20);
	SET idus = (SELECT u.iduser FROM user u where u.email = ma and u.password = SHA(pass));
	if (idus IS NOT NULL) THEN
    	UPDATE token t SET t.token = tok,expirationDate = TIMESTAMPADD(HOUR,1,CURRENT_TIMESTAMP)
			WHERE t.iduser = idus;
		select idus;
	else
		select -1;
	END IF;
END$$

DROP PROCEDURE IF EXISTS `verifyRegister`$$
CREATE DEFINER=`khouryfolch`@`localhost` PROCEDURE `verifyRegister`(IN `idus` BIGINT UNSIGNED, IN `tok` VARCHAR(33))
    NO SQL
BEGIN
	DECLARE correct TINYINT(1);
	DECLARE mailValid TINYINT(1);
	SET correct = (SELECT count(t.token) FROM token t where t.token = tok and iduser = idus);
	SET mailValid = (select now() < `expirationDate` from token where iduser = idus and token = tok);
	if (correct = 1 AND mailValid) THEN
    	UPDATE user SET isVerified = TRUE WHERE iduser = idus;
	END IF;
	if (mailValid IS NULL) THEN
		SET mailValid = -1;
	END IF;
	SELECT mailValid;
END$$

DELIMITER ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `audio`
--

DROP TABLE IF EXISTS `audio`;
CREATE TABLE IF NOT EXISTS `audio` (
  `idaudio` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `extension` varchar(4) NOT NULL COMMENT 'De moment es un string, es pot canviar per un int',
  `data` mediumblob NOT NULL COMMENT 'canço',
  `date` date NOT NULL,
  `rating_total` float unsigned NOT NULL DEFAULT '0',
  `n_puntuations` bigint(20) unsigned NOT NULL DEFAULT '0',
  `idlicense` int(3) NOT NULL COMMENT '0si-si,1si-no,2no-si,3no-no,4misma manera - si,5 misma manera -no',
  `comment` varchar(255) NOT NULL,
  `diskimage` bigint(20) unsigned DEFAULT NULL COMMENT 'si es null, es una imatge nova que esta al filesystem',
  `songimage` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`idaudio`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=56 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `author`
--

DROP TABLE IF EXISTS `author`;
CREATE TABLE IF NOT EXISTS `author` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) DEFAULT '',
  `real_name` varchar(50) NOT NULL,
  `rating_total` float unsigned NOT NULL DEFAULT '0',
  `n_puntuations` bigint(20) unsigned NOT NULL DEFAULT '0',
  `web` varchar(50) NOT NULL,
  `description` varchar(200) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `id_2` (`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=17 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `disk`
--

DROP TABLE IF EXISTS `disk`;
CREATE TABLE IF NOT EXISTS `disk` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `release_date` date NOT NULL,
  `rating_total` float unsigned NOT NULL DEFAULT '0',
  `n_puntuations` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=6 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `diskuser`
--

DROP TABLE IF EXISTS `diskuser`;
CREATE TABLE IF NOT EXISTS `diskuser` (
  `iduser` bigint(20) unsigned NOT NULL,
  `iddisk` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`iduser`,`iddisk`),
  KEY `iddisk` (`iddisk`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='aquesta taula mostra els discs que un usuari pot modificar';

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `favorite`
--

DROP TABLE IF EXISTS `favorite`;
CREATE TABLE IF NOT EXISTS `favorite` (
  `idmessage` bigint(20) unsigned NOT NULL,
  `iduser` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`idmessage`,`iduser`),
  KEY `iduser` (`iduser`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `genere`
--

DROP TABLE IF EXISTS `genere`;
CREATE TABLE IF NOT EXISTS `genere` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `genere` (`name`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=3 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `historic`
--

DROP TABLE IF EXISTS `historic`;
CREATE TABLE IF NOT EXISTS `historic` (
  `iduser` bigint(20) unsigned NOT NULL,
  `idsong` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`iduser`,`idsong`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `message`
--

DROP TABLE IF EXISTS `message`;
CREATE TABLE IF NOT EXISTS `message` (
  `idmessage` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `iduser` bigint(20) unsigned NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `idanswer` bigint(20) unsigned DEFAULT NULL COMMENT 'missatge al qual fa resposta, null si no fa resposta a cap',
  `text` varchar(1000) CHARACTER SET utf8 COLLATE utf8_spanish2_ci NOT NULL,
  PRIMARY KEY (`idmessage`),
  KEY `iduser` (`iduser`),
  KEY `idanswer` (`idanswer`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `playlist`
--

DROP TABLE IF EXISTS `playlist`;
CREATE TABLE IF NOT EXISTS `playlist` (
  `idplaylist` int(11) NOT NULL AUTO_INCREMENT,
  `idusuari` bigint(20) unsigned NOT NULL,
  `name` varchar(50) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`idplaylist`,`idusuari`),
  KEY `idusuari` (`idusuari`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=12 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `playlistaudio`
--

DROP TABLE IF EXISTS `playlistaudio`;
CREATE TABLE IF NOT EXISTS `playlistaudio` (
  `idaudioplaylist` int(11) NOT NULL AUTO_INCREMENT,
  `idaudio` bigint(20) unsigned NOT NULL,
  `idplaylist` int(11) NOT NULL,
  PRIMARY KEY (`idaudioplaylist`),
  KEY `iduser` (`idplaylist`),
  KEY `idaudio` (`idaudio`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=23 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `prize`
--

DROP TABLE IF EXISTS `prize`;
CREATE TABLE IF NOT EXISTS `prize` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL,
  `description` varchar(256) NOT NULL,
  `expirationdate` int(11) DEFAULT NULL,
  `points` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `puntuation`
--

DROP TABLE IF EXISTS `puntuation`;
CREATE TABLE IF NOT EXISTS `puntuation` (
  `idaudio` bigint(20) unsigned NOT NULL,
  `iduser` bigint(20) unsigned NOT NULL,
  `puntuation` float(2,1) unsigned NOT NULL,
  PRIMARY KEY (`idaudio`,`iduser`),
  KEY `iduser` (`iduser`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `reward`
--

DROP TABLE IF EXISTS `reward`;
CREATE TABLE IF NOT EXISTS `reward` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `iduser` bigint(20) unsigned NOT NULL,
  `idprize` int(11) NOT NULL,
  `date` date NOT NULL,
  PRIMARY KEY (`id`),
  KEY `iduser` (`iduser`),
  KEY `iduser_2` (`iduser`),
  KEY `idprize` (`idprize`),
  KEY `iduser_3` (`iduser`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `similituds`
--

DROP TABLE IF EXISTS `similituds`;
CREATE TABLE IF NOT EXISTS `similituds` (
  `idsong1` bigint(20) NOT NULL,
  `idsong2` bigint(20) NOT NULL,
  `simil` decimal(10,10) NOT NULL,
  PRIMARY KEY (`idsong1`,`idsong2`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `songauthor`
--

DROP TABLE IF EXISTS `songauthor`;
CREATE TABLE IF NOT EXISTS `songauthor` (
  `idsong` bigint(20) unsigned NOT NULL,
  `idauthor` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`idsong`,`idauthor`),
  KEY `idauthor` (`idauthor`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `songdisk`
--

DROP TABLE IF EXISTS `songdisk`;
CREATE TABLE IF NOT EXISTS `songdisk` (
  `idsong` bigint(20) unsigned NOT NULL,
  `iddisk` bigint(20) unsigned NOT NULL,
  `position` int(10) unsigned NOT NULL,
  PRIMARY KEY (`idsong`,`iddisk`),
  KEY `iddisk` (`iddisk`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `songgenere`
--

DROP TABLE IF EXISTS `songgenere`;
CREATE TABLE IF NOT EXISTS `songgenere` (
  `idsong` bigint(20) unsigned NOT NULL,
  `idgenere` int(11) NOT NULL,
  PRIMARY KEY (`idsong`,`idgenere`),
  KEY `idgenere` (`idgenere`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `songuser`
--

DROP TABLE IF EXISTS `songuser`;
CREATE TABLE IF NOT EXISTS `songuser` (
  `idsong` bigint(20) unsigned NOT NULL,
  `iduser` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`idsong`,`iduser`),
  KEY `iduser` (`iduser`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='cançons que l''usuari ha penjat';

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `token`
--

DROP TABLE IF EXISTS `token`;
CREATE TABLE IF NOT EXISTS `token` (
  `iduser` bigint(20) unsigned NOT NULL,
  `expirationDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'expiration date of the token',
  `token` varchar(33) NOT NULL,
  PRIMARY KEY (`iduser`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user`
--

DROP TABLE IF EXISTS `user`;
CREATE TABLE IF NOT EXISTS `user` (
  `iduser` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `email` varchar(50) NOT NULL,
  `password` varchar(50) NOT NULL,
  `isVerified` tinyint(1) NOT NULL,
  `points` int(11) NOT NULL DEFAULT '0',
  `facebook_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `url_image` varchar(100) NOT NULL,
  PRIMARY KEY (`iduser`),
  UNIQUE KEY `email` (`email`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=17 ;

--
-- Restricciones para tablas volcadas
--

--
-- Filtros para la tabla `diskuser`
--
ALTER TABLE `diskuser`
  ADD CONSTRAINT `diskuser_ibfk_1` FOREIGN KEY (`iduser`) REFERENCES `user` (`iduser`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `diskuser_ibfk_2` FOREIGN KEY (`iddisk`) REFERENCES `disk` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `favorite`
--
ALTER TABLE `favorite`
  ADD CONSTRAINT `favorite_ibfk_1` FOREIGN KEY (`iduser`) REFERENCES `user` (`iduser`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `favorite_ibfk_2` FOREIGN KEY (`idmessage`) REFERENCES `message` (`idmessage`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `historic`
--
ALTER TABLE `historic`
  ADD CONSTRAINT `historic_ibfk_1` FOREIGN KEY (`iduser`) REFERENCES `user` (`iduser`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `message`
--
ALTER TABLE `message`
  ADD CONSTRAINT `message_ibfk_1` FOREIGN KEY (`iduser`) REFERENCES `user` (`iduser`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `message_ibfk_2` FOREIGN KEY (`idanswer`) REFERENCES `message` (`idmessage`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `playlist`
--
ALTER TABLE `playlist`
  ADD CONSTRAINT `playlist_ibfk_1` FOREIGN KEY (`idusuari`) REFERENCES `user` (`iduser`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `playlistaudio`
--
ALTER TABLE `playlistaudio`
  ADD CONSTRAINT `playlistaudio_ibfk_1` FOREIGN KEY (`idplaylist`) REFERENCES `playlist` (`idplaylist`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `puntuation`
--
ALTER TABLE `puntuation`
  ADD CONSTRAINT `puntuation_ibfk_1` FOREIGN KEY (`iduser`) REFERENCES `user` (`iduser`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `reward`
--
ALTER TABLE `reward`
  ADD CONSTRAINT `reward_ibfk_1` FOREIGN KEY (`idprize`) REFERENCES `prize` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `reward_ibfk_2` FOREIGN KEY (`iduser`) REFERENCES `user` (`iduser`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `songauthor`
--
ALTER TABLE `songauthor`
  ADD CONSTRAINT `songauthor_ibfk_1` FOREIGN KEY (`idauthor`) REFERENCES `author` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `songdisk`
--
ALTER TABLE `songdisk`
  ADD CONSTRAINT `songdisk_ibfk_1` FOREIGN KEY (`iddisk`) REFERENCES `disk` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `songgenere`
--
ALTER TABLE `songgenere`
  ADD CONSTRAINT `songgenere_ibfk_1` FOREIGN KEY (`idgenere`) REFERENCES `genere` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `songuser`
--
ALTER TABLE `songuser`
  ADD CONSTRAINT `songuser_ibfk_1` FOREIGN KEY (`iduser`) REFERENCES `user` (`iduser`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `token`
--
ALTER TABLE `token`
  ADD CONSTRAINT `token_ibfk_1` FOREIGN KEY (`iduser`) REFERENCES `user` (`iduser`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Filtros para la tabla `user`
--
ALTER TABLE `user`
  ADD CONSTRAINT `user_ibfk_1` FOREIGN KEY (`iduser`) REFERENCES `author` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
