<?php
/**
 * Created by Albert Folch.
 */
require_once 'generalfunction.php';

function loadPoints(){
    session_start();
    $con = getCon();
    $query = "SELECT points from user where id = ".$_SESSION['iduser'];
    $result = $con->query($query);
    $row = $result->fetch_assoc();
    $_SESSION['points'] = $row['points'];
    $con->close();
}
function incrementPoints($points){
    $con = getCon();
    loadPoints();
    $query = "UPDATE `musicdb`.`author` SET points = ? WHERE `author`.`id` =?";
    $stmt = $con->prepare($query);
    $stmt->bind_param('ii',$points,$_SESSION['iduser']);
    $stmt->execute();
    $stmt->close();
}
function sendMail($from, $passFrom, $to, $subject, $message)
{
    require_once('libs/PHPMailer-master/class.phpmailer.php');
    require_once('libs/PHPMailer-master/class.smtp.php');

    $mail = new PHPMailer();
    $mail->IsSMTP();
    $mail->Debugoutput = 'html';
    $mail->CharSet = 'iso-8859-1';
    $mail->Host = 'smtp.gmail.com';
    $mail->Port = 465;
    $mail->SMTPSecure = 'ssl';
    $mail->SMTPAuth = true;
    $mail->Username = $from;
    $mail->Password = $passFrom;
    $mail->SetFrom($from, 'Music Register');
    $mail->AddAddress($to);
    $mail->Subject = $subject;
    $mail->MsgHTML(nl2br($message));
    $mail->addCustomHeader('X-Mailer: PHP/' . phpversion() . ' rn');
    $mail->addCustomHeader('MIME-Version: 1.0' . 'n');
    if (!$mail->Send()) {
        echo 'Mailer Error: ' . $mail->ErrorInfo;
    }
}

function checkBinarySong($file)
{

    $tmpname = $file['tmp_name'];
    $songsize = $file['size'];
    $songnamefile = $file['name'];
    $imageFileType = pathinfo($songnamefile, PATHINFO_EXTENSION);
    $allowed_extensions = array('mp3', 'ogg');
    $max_allowed_file_size = 16 * pow(2, 20);//16 MB, size of MEDIUMBLOB
    if ($songsize <= $max_allowed_file_size) {

        for ($j = 0; $j < sizeof($allowed_extensions); $j++) {

            if (strcasecmp($allowed_extensions[$j], $imageFileType) == 0) {


                $fileExec = strtolower(exec('file ' . $tmpname));


                if (
                    strpos($fileExec, 'audio file') //sprepare.mp3: Audio file with ID3 version 2.3.0
                    or strpos($fileExec,'mpeg')
                    or strtolower((strpos($fileExec, 'data') and substr($fileExec, strlen($tmpname) + 2, strlen('data'))) == 'data')//godlike.mp3: data
                    or strlen($fileExec) == 0
                    or strtolower(substr($fileExec, strlen($tmpname) + 2, strlen('ogg data'))) == 'ogg data' //Epoq-LepidopteraRed.ogg: Ogg data UNKNOWN REVISION 92
                ) {

                    return 1;
                }


            }

        }

    }

    return 0;
}

function deleteImage($destination, $userid, $diskidORsongid)
{
    foreach (glob($destination . '' . $userid . '_' . $diskidORsongid . '.*') as $filename) {
        unlink($filename);
    }
}

function deleteFilePath($path)
{
    foreach (glob($path . '.*') as $filename) {
        unlink($filename);
    }
}

function getFile($path)
{
    foreach (glob($path . '.*') as $filename) {
        return $filename;
    }
    return null;
}
function getFilePath($path)
{
    foreach (glob($path) as $filename) {
        return $filename;
    }
    return null;
}
function deleteFromPathAllImagesExcept($path,$f){
    foreach (glob($path . '.*') as $filename) {
        if($filename != $f)
            unlink($filename);
    }
}
function getURLuser($id){
    $id = intval($id);
    $con = getCon();
    $url = '';

    if ($stmt = $con->prepare('call getUrlUser(?)')) {


        $stmt->bind_param("i", $id);

        // Execute the statement.
        $stmt->execute();


        // Get the variables from the query.
        $stmt->bind_result($url);

        // Fetch the data.
        $stmt->fetch();


        $stmt->close();
    }
    mysqli_close($con);
    global $default_author_image;
    if (strpos($url,'http') === false and strlen($url) > 0) {//quan no tingui http agrego time()
        $url .= '?'.time();
    }else if (strlen($url) == 0) {
        $url = $default_author_image;
    }


    return $url;
}


function upperCaseBySpaces(&$name)
{
    $arraySpaces = explode(' ', $name);
    $text = '';
    $n = count($arraySpaces);
    for ($i = 0; $i < $n; $i++) {
        $text .= ucfirst($arraySpaces[$i]) . ' ';
    }
    $name = trim($text);
}
function decode(&$txt){
    $txt = htmlentities($txt, ENT_SUBSTITUTE, 'UTF-8');
}

/**
 * Returns a number indicating the number of favorites of the message
 * @param $messageid
 * @param $conn
 * @return int
 */
function getFavorites($messageid, &$conn)
{

    $n = -1;
    $messageid = intval($messageid);
    if ($conn->more_results())
        $conn->next_result();
    if ($stmt = $conn->prepare('call getFavorites(?)')) {

        //$stmt->bind_param("ii", $index,$nMessagesPerFetch);
        $stmt->bind_param("i", $messageid);

        // Execute the statement.
        $stmt->execute();


        // Get the variables from the query.
        $stmt->bind_result($n);

        // Fetch the data.
        $stmt->fetch();


        $stmt->close();
    }
    return $n;
}

/**
 * Returns 1 or 0 depending if user likes this message so user's heart will be red
 * @param $messageid
 * @param $userid
 * @param $conn
 * @return int
 */
function getMyFav($messageid, $userid, &$conn)
{
    $n = -1;
    $messageid = intval($messageid);
    $userid = intval($userid);
    if ($conn->more_results())
        $conn->next_result();
    if ($stmt = $conn->prepare('call getMyFav(?,?)')) {

        $stmt->bind_param("ii", $messageid, $userid);

        // Execute the statement.
        $stmt->execute();


        // Get the variables from the query.
        $stmt->bind_result($n);

        // Fetch the data.
        $stmt->fetch();


        $stmt->close();
    }
    return $n;
}
function getMessageRecoverPassword($email, $domain, $token){
    return '

Your password has been changed, you can canLogin with your new credentials after you have pressed the url below.

Please click this link to confirm your new password:
<a href="http://' . $domain . '/changePassword.php?mail=' . $email . '&token=' . $token.'#about">http://' . $domain . '/changePassword.php?mail=' . $email . '&token=' . $token.'</a>';
}
function getMessage($iduser, $domain, $token)
{

    return '

    Thanks for signing up!
    Your account has been created, you can login with your credentials after you have activated your account by pressing the url below.

    Please click this link to activate your account:
    <a href="http://' . $domain . '/verify.php?id=' . $iduser . '&token=' . $token . '#about">http://' . $domain . '/verify.php?id=' . $iduser . '&token=' . $token . '</a>

    If you cannot enter with this link go to: <a href="' . $domain . '/resendLink.php?#about">here</a>';
}