<?php
/**
 * Created by Albert Folch
 */
require_once 'generalfunction.php';
require_once 'functions.php';

session_start();
$userid = $_SESSION['iduser'];


$conn = getCon();

getUploadedSongs($conn, $userid, $imageSongDestination, $imageDiskDestination);

$conn->close();

function getUploadedSongs($conn, $userid, $songImageDest, $diskImageDest)
{
    $json = array("songs" => []);
    if (isset($userid)) {


        $songid = -1;
        $songname = '';
        $songdate = '';
        $author = '';
        $genre = '';
        $ext = '';
        $disk = '';
        $license = 0;

        if ($stmt = $conn->prepare('CALL getSongsUser(?)')) {

            // Bind a variable to the parameter as a string.
            $stmt->bind_param('i', $userid);
            // Execute the statement.
            $stmt->execute();
            $stmt->store_result();
            // Get the variables from the query.
            $stmt->bind_result($songid, $songname, $songdate, $ext, $disk, $license);

            $authorsArray = [];
            $genresArray = [];

            while ($stmt->fetch()) {
                $id = -1;
                $ids = [];
                if ($conn->more_results())
                    $conn->next_result();
                if ($stmt2 = $conn->prepare('CALL getAuthorsSong(?)')) {

                    // Bind a variable to the parameter as a string.
                    $stmt2->bind_param('i', $songid);
                    // Execute the statement.
                    $stmt2->execute();
                    $stmt2->store_result();
                    // Get the variables from the query.
                    $stmt2->bind_result($author, $id);


                    $authors = '';
                    while ($stmt2->fetch()) {

                        upperCaseBySpaces($author);
                        $authors .= $author . ',';
                        array_push($ids, $id);
                    }

                    $authors = rtrim($authors, ',');

                    $authorsArray = explode(',', $authors);

                    // Close the prepared statement.
                    $stmt2->close();
                } else {
                    echo 'authors a fallat;';
                }

                if ($conn->more_results())
                    $conn->next_result();
                if ($stmt3 = $conn->prepare('CALL getGenresSong(?)')) {

                    // Bind a variable to the parameter as a string.
                    $stmt3->bind_param('i', $songid);
                    // Execute the statement.
                    $stmt3->execute();
                    $stmt3->store_result();
                    // Get the variables from the query.
                    $stmt3->bind_result($genre);

                    $genres = '';
                    while ($stmt3->fetch()) {
                        $genres .= ucfirst($genre) . ',';
                    }
                    $genres = rtrim($genres, ",");
                    $genresArray = explode(',', $genres);

                    // Close the prepared statement.
                    $stmt3->close();
                } else {
                    echo 'generes a fallat;';
                }


                $tmpid = $songid;
                $desttmp = $songImageDest;
                if ($disk != null) {
                    $tmpid = $disk;
                    $desttmp = $diskImageDest;
                } else {
                    $disk = '';
                }
                $url = '';
                foreach (glob($desttmp . $userid . '_' . $tmpid . '.*') as $filename) {
                    $url = $filename;
                    break;
                }
                array_push($json["songs"], array('id' => $songid,
                    'gen' => '' . implode(',', $genresArray) . '',
                    'aut' => '' . implode(',', $authorsArray) . '',
                    'name' => $songname,
                    'date' => $songdate,
                    'disk' => $disk,
                    'url' => $url,
                    'license' => $license,
                    'ids' => $ids
                ));

            }


            // Close the prepared statement.
            $stmt->close();
        } else {
            echo 'songs a fallat;';
        }
    }
    echo json_encode($json);
}