<?php
/**
 * Created by Albert Folch.
 * Given a disk name this service returns a Json in this format:
 * { disksongs : ['{
 *              "songname":' + songname + ' ,
 *              "author":' + authorsSeparatedByCommas + ' ,
 *              "date":' + releaseDate + ' ,
 *              "id":' + songid + ' ,
 *              "genre":' + genresSeparatedByCommas + '"
 *              }'],
 *   date : "2015-03-16",
 *   image: url
 * };
 */
require_once 'generalfunction.php';

session_start();
$userid = $_SESSION['iduser'];

$json = array('disks' => []);
if (isset($userid)) {

    $conn = getCon();

    if ($stmt = $conn->prepare('CALL getMyDisks(?)')) {


        $stmt->bind_param('i', $userid);

        // Execute the statement.
        $stmt->execute();

        // Get the variables from the query.
        $stmt->bind_result($iddisk, $diskname, $date);
        $stmt->store_result();

        while ($stmt->fetch()) {
            $f = '';
            foreach (glob($imageDiskDestination . '' . $userid . '_' . $iddisk . '.*') as $filename) {
                $f = $filename;
                break;
            }
            $songs = [];
            if ($conn->more_results())
                $conn->next_result();
            if ($stmt2 = $conn->prepare('CALL getSongsOfDisk(?)')) {


                $stmt2->bind_param('i', $iddisk);

                // Execute the statement.
                $stmt2->execute();

                // Get the variables from the query.
                $stmt2->bind_result($songid);


                while ($stmt2->fetch()) {

                    array_push($songs, $songid);

                }
                // Close the prepared statement.
                $stmt2->close();

            }


            array_push($json['disks'], array(
                "id" => $iddisk,
                'name' => $diskname,
                'date' => $date,
                'url' => $f,
                'songs' => $songs
            ));

        }
        // Close the prepared statement.
        $stmt->close();

    }


    mysqli_close($conn);


}
echo json_encode($json);
