<?php
/**
 * Created by Albert Folch.
 */
require_once 'acces.php';

if (isLogged()) {
    header('Location: index.php');
}

?>
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <title>Login</title>

    <script src="myjs/commons.js"></script>
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <meta http-equiv="X-UA-Compatible" content="IE=edge">


    <link rel="stylesheet" href="libs/bootstrap/awesome/css/bootstrap.min.css" type="text/css">

    <link href='http://fonts.googleapis.com/css?family=Open+Sans:300italic,400italic,600italic,700italic,800italic,400,300,600,700,800' rel='stylesheet' type='text/css'>
    <link href='http://fonts.googleapis.com/css?family=Merriweather:400,300,300italic,400italic,700,700italic,900,900italic' rel='stylesheet' type='text/css'>
    <link rel="stylesheet" href="libs/bootstrap/awesome/font-awesome/css/font-awesome.min.css" type="text/css">

    <link rel="stylesheet" href="libs/bootstrap/awesome/css/animate.min.css" type="text/css">

    <link rel="stylesheet" href="libs/bootstrap/awesome/css/creative.css" type="text/css">

    <!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
    <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
    <script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
    <![endif]-->

</head>

<body id="page-top" onload="passRight = true;">

<nav id="mainNav" class="navbar navbar-default navbar-fixed-top">
    <div class="container-fluid">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a class="navbar-brand page-scroll" href="#page-top">UP</a>
        </div>

        <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
            <ul class="nav navbar-nav navbar-right">
                <li>
                    <a class="page-scroll" href="#about">Login</a>
                </li>
                <li>
                    <a class="page-scroll" href="#services">Services</a>
                </li>
                <li>
                    <a class="page-scroll" href="#contact">Contact</a>
                </li>
            </ul>
        </div>
    </div>
</nav>

<header>
    <div class="header-content">
        <div class="header-content-inner">
            <h1>Unlimited music</h1>
            <hr>
            <p>Start sharing your music and enjoy all the music we have wherever you are</p>
            <a href="#about" class="btn btn-primary btn-xl page-scroll">Find Out More</a>
        </div>
    </div>
</header>

<section class="bg-primary" id="about">
    <div class="container">
        <div class="row">
            <div class="col-lg-8 col-lg-offset-2 text-center">
                <h2 class="section-heading">We've got what you need!</h2>
                <hr class="light">


                <form class="text-center" action="loginValidation.php" method="POST">

                    <div class="control-group">
                        <div class="controls">
                            <input type="text" id="email" name="email" placeholder="E-mail" class="form-control"
                                   onkeyup="checkMail(this.value,0)" oninput="checkMail(this.value,0)">

                            <p id="emailcheck"></p>
                        </div>
                    </div>

                    <div class="control-group">
                        <div class="controls">
                            <input type="password" id="password" name="password" placeholder="Password" class="form-control"
                                >

                            <p id="passwordcheck1"></p>
                        </div>
                    </div>


                    <div class="control-group">
                        <button class="btn btn-default btn-xl" onclick="return isFormLoginCorrect()">Login</button>


                    </div>


                </form>
                <hr class="light">
                <form  class="text-center" id="formface" method="post" action="loginFacebook.php">
                    <fb:login-button scope="public_profile,email" onlogin="validate();" >Login</fb:login-button>
                </form>

                <br>
                <p >Not registered? <a href="register.php?#about" style="color:#000000;">Sign up</a></p>

                <p >Forgot password? <a href="resetPassword.php?#about" style="color:#000000;">Reset password</a></p>

            </div>
        </div>
    </div>
</section>

<section id="services">
    <div class="container">
        <div class="row">
            <div class="col-lg-12 text-center">
                <h2 class="section-heading">At Your Service</h2>
                <hr class="primary">
            </div>
        </div>
    </div>
    <div class="container">
        <div class="row">
            <div class="col-lg-3 col-md-6 text-center">
                <div class="service-box">
                    <i class="fa fa-4x fa-music wow bounceIn text-primary"></i>
                    <h3>Awesome music</h3>
                    <p class="text-muted">New music every day.</p>
                </div>
            </div>
            <div class="col-lg-3 col-md-6 text-center">
                <div class="service-box">
                    <i class="fa fa-4x fa-paper-plane wow bounceIn text-primary" data-wow-delay=".1s"></i>
                    <h3>Ready to Ship</h3>
                    <p class="text-muted">Ready to listen anywhere, anytime.</p>
                </div>
            </div>
            <div class="col-lg-3 col-md-6 text-center">
                <div class="service-box">
                    <i class="fa fa-4x fa-share-square-o wow bounceIn text-primary" data-wow-delay=".2s"></i>
                    <h3>Social</h3>
                    <p class="text-muted">Share your new amazing songs to become famous!</p>
                </div>
            </div>
            <div class="col-lg-3 col-md-6 text-center">
                <div class="service-box">
                    <i class="fa fa-4x fa-heart wow bounceIn text-primary" data-wow-delay=".3s"></i>
                    <h3>Made with Love</h3>
                    <p class="text-muted">We improve our website every day only for you!</p>
                </div>
            </div>
        </div>
    </div>
</section>


<section id="contact">
    <div class="container">
        <div class="row">
            <div class="col-lg-8 col-lg-offset-2 text-center">
                <h2 class="section-heading">Let's Get In Touch!</h2>
                <hr class="primary">
                <p>Do you have any suggestions? That's great! Send us an email and we will get back to you as soon as possible!</p>
            </div>
            <div class="col-lg-8 col-lg-offset-2 text-center">
                <i class="fa fa-4x fa-var-music wow bounceIn text-primary" style="visibility: visible; animation-name: bounceIn; -webkit-animation-name: bounceIn;"></i>
                <i class="fa fa-envelope-o fa-3x wow bounceIn" data-wow-delay=".1s"></i>
                <p><a href="mailto:khouryfolch@gmail.com">khouryfolch@gmail.com</a></p>
            </div>
        </div>
    </div>
</section>

<script src="libs/jquery/jquery-1.11.2.min.js"></script>

<script src="libs/bootstrap/awesome/js/bootstrap.min.js"></script>

<script src="libs/bootstrap/awesome/js/jquery.easing.min.js"></script>
<script src="libs/bootstrap/awesome/js/jquery.fittext.js"></script>
<script src="libs/bootstrap/awesome/js/wow.min.js"></script>

<script src="libs/bootstrap/awesome/js/creative.js"></script>





<script type="text/javascript" src="myjs/validateFunctions.js"></script>
<script>
    (function (d, s, id) {
        var js, fjs = d.getElementsByTagName(s)[0];
        if (d.getElementById(id)) return;
        js = d.createElement(s);
        js.id = id;
        js.src = "http://connect.facebook.net/es_ES/sdk.js";
        fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));
    window.fbAsyncInit = function () {
        FB.init({
            appId: '819265414809824',
            cookie: true,
            xfbml: true,
            version: 'v2.0'
        });
    };
    function validate() {
        FB.getLoginStatus(function (response) {
            if (response.status == 'connected') {
                FB.api('/me', function (response) {
                    var input = $("<input>")
                        .attr("type", "hidden")
                        .attr("name", "id").val(response.id);
                    var input2 = $("<input>")
                        .attr("type", "hidden")
                        .attr("name", "name").val(response.name);
                    var input3 = $("<input>")
                        .attr("type", "hidden")
                        .attr("name", "email").val(response.email);
                    var form = $('#formface');
                    form.append($(input), $(input2), $(input3));
                    form.submit();
                });
            } else if (response.status == 'not_authorized') {
                alert('App not authorized');
            } else {
                alert('You must log in your facebook');
            }
        });
    }
</script>

</body>
</html>
