<?php
/**
 * Created by Albert Folch
 */
require_once 'generalfunction.php';
function getSong($user, $idgenere){
    $conn = getCon();
    $idsong = recommend($user, $conn, $idgenere);
    mysqli_close($conn);
    return $idsong;
}

function recommend($user, &$conn, $idgenere)
{

    $idsong = -1;
    $punt = -1;
    $idsong1 = -1;
    $idsong2 = -1;
    $simil = -1;
    $myPuntutations = [];
    $mostLiked = [];
    $new = [];
    $ponderations = [];
    $goodPuntuated = 2.5;
    if (!isset($idgenere)) {
        $sql1 = 'CALL getMyPuntuations(' . $user . ')';
        $sql2 = 'CALL getSongsNotPuntuatedNotListened(' . $user . ','.$goodPuntuated.')';
        $sql3 = 'CALL getRandomSongNotRecently(' . $user . ')';
    } else {
        $sql1 = 'CALL getMyPuntuationsGenre(' . $user . ',' . $idgenere . ')';
        $sql2 = 'CALL getSongsNotPuntuatedNotListenedGenre(' . $user . ',' . $idgenere . ','.$goodPuntuated.')';
        $sql3 = 'CALL getRandomSongNotRecentlyGenre(' . $user . ',' . $idgenere . ')';
    }
    if ($stmt = $conn->prepare($sql1)) {

        // Execute the statement.
        $stmt->execute();

        // Get the variables from the query.
        $stmt->bind_result($idsong, $punt);


        while ($stmt->fetch()) {

            $myPuntutations[$idsong] = $punt;
            if ($punt >= $goodPuntuated)
                $mostLiked[$idsong] = $punt;

        }
        // Close the prepared statement.

        $stmt->close();

    }
    if (count($myPuntutations) > 0) {
        //recomenar barreja de noves (no historic i no puntuades) i puntuades be

        $songsNotPuntuated = [];


        if ($conn->more_results())
            $conn->next_result();
        if ($stmt = $conn->prepare($sql2)) {
            // Execute the statement.
            $stmt->execute();

            // Get the variables from the query.
            $stmt->bind_result($idsong1, $idsong2, $simil);


            while ($stmt->fetch()) {
                if (!array_key_exists($idsong1, $songsNotPuntuated)) {
                    $songsNotPuntuated[$idsong1] = [$simil, $simil * $myPuntutations[$idsong2]];
                    //$new[$idsong1] = 0;
                } else {

                    $songsNotPuntuated[$idsong1][0] += $simil;
                    $songsNotPuntuated[$idsong1][1] += $simil * $myPuntutations[$idsong2];
                }
            }
            // Close the prepared statement.
            $stmt->close();

        }
        foreach ($songsNotPuntuated as $song => $value) {
            if ($value[0] == 0)
                $normalized = 0;
            else
                $normalized = $value[1] / $value[0];

            $new[$song] = $normalized;


        }
        $suma = 0;


        $len = count($mostLiked) + count($new);
        //puntuations range = [1 - 5]
        foreach ($mostLiked as $key => $p) {
            $val = ($p / $len);
            $suma += $val;
            $ponderations[$key] = $val;

        }


        foreach ($new as $key => $p) {
            if ($p == 0)
                $p = 0.1;
            $val = ($p / $len);
            $suma += $val;
            $ponderations[$key] = $val;
        }
        //Normalize and accumulate the values
        $total = 0;
        foreach ($ponderations as $key => $p) {
            $v = $p / $suma;
            $total += $v;
            $ponderations[$key] = $total;

        }
        //Sort
        asort($ponderations);

        $idsong = findRandomWeighted($ponderations);
    } else {
        //random del genere o del total
        if ($conn->more_results())
            $conn->next_result();
        if ($stmt = $conn->prepare($sql3)) {

            // Execute the statement.
            $stmt->execute();

            // Get the variables from the query.
            $stmt->bind_result($idsong);


            $stmt->fetch();
            // Close the prepared statement.

            $stmt->close();

        }
    }

    return $idsong;
}

function findRandomWeighted($items)
{


    $r = mt_rand() / mt_getrandmax();
    foreach ($items as $key => $p) {
        if ($r <= $p) {
            return $key;
        }
    }
    return key(array_slice($items, -1, 1, TRUE));
}

