<?php
/**
 * Created by Albert Folch.
 */

require_once 'generalfunction.php';
require_once 'functions.php';


$jsonSongsEncoded = $_POST["tags"];

session_start();
$userid = $_SESSION['iduser'];

if (strlen($jsonSongsEncoded) > 0) {

    $jsonDisk = json_decode($jsonSongsEncoded);
    $conn = getCon();

    $uploaded = 0;
    if (strlen(rtrim($jsonDisk->songs)) > 0)
        $disksongs = explode(',', $jsonDisk->songs);
    else
        $disksongs = [];
    $diskid = '';
    $url = '';
    $engDiskDate = '';
    $diskname = $jsonDisk->name;
    $releasedate = $jsonDisk->date;
    $antid = $jsonDisk->id;


    $conn->autocommit(false);
    $conn->begin_transaction();
    if ($stmt = $conn->prepare('call updateDisk(?,?,?,?)')) {


        // Bind a variable to the parameter as a string.
        $stmt->bind_param("sisi", $diskname, $userid, $releasedate, $jsonDisk->id);

        // Execute the statement.
        $stmt->execute();


        // Get the variables from the query.
        $stmt->bind_result($diskid);
        $diskid = intval($diskid);
        // Fetch the data.
        $stmt->fetch();

        $songnamefilesystem = $tmpDestinationDisk . $userid . '_' . $_POST['currentDisk'];

        $f = getFile($songnamefilesystem);
        if (!is_null($f)) {//if image is in tmpDisk
            $ext = pathinfo($f, PATHINFO_EXTENSION);
            $url = $imageDiskDestination . $userid . '_' . $diskid . '.' . $ext;
            rename($songnamefilesystem . '.' . $ext, $url);
        } else {
            $url = $jsonDisk->url;
        }
        deleteFromPathAllImagesExcept($imageDiskDestination . $userid . '_' . $diskid, $url);


        $stmt->close();
    }

    if ($antid != -1) {

        if ($stmt = $conn->prepare('call deleteSongsOfDisk(?)')) {

            $stmt->bind_param("i", $diskid);

            // Execute the statement.
            $stmt->execute();


            $stmt->close();


        }
        if (count($disksongs) == 0) {
            $uploaded = 1;
        } else {
            $i = 0;
            foreach ($disksongs as $song) {
                $i++;

                $song = intval($song);
                if ($stmt = $conn->prepare('call addSongDisk(?,?,?,?)')) {

                    $stmt->bind_param("iiii", $song, $diskid, $userid, $i);

                    // Execute the statement.
                    $stmt->execute();
                    // Get the variables from the query.
                    $stmt->bind_result($uploaded);
                    // Fetch the data.
                    $stmt->fetch();


                    $stmt->close();
                    if ($uploaded == 0)
                        break;


                }
            }

            if ($stmt = $conn->prepare('call updateAlbumPuntuation(?)')) {


                $stmt->bind_param("i", $diskid);

                // Execute the statement.
                $stmt->execute();


                $stmt->close();
            }
        }

    } else {
        $uploaded = 1;
    }


    if ($uploaded) {

        unset($jsonDisk);
        $jsonDisk->id = $diskid;
        $conn->commit();
    } else {
        $conn->rollback();
    }
    $jsonDisk->uploaded = $uploaded;
    $jsonDisk->url = $url;


    echo json_encode($jsonDisk);
    mysqli_close($conn);
} else {
    echo '0ERROR: check post_max_size in php.ini and restart the web server and max_file_uploads';
}


function deleteDiskSong($conn, $disk, $song)
{

    if ($stmt = $conn->prepare('call deleteDiskSong(?,?)')) {//rollback of addSongDisk

        $stmt->bind_param("ii", $disk, $song);

        // Execute the statement.
        $stmt->execute();
        $stmt->close();
    }

}
