<?php
/**
 * Created by Albert Folch.
 */

require_once 'generalfunction.php';
require_once 'functions.php';
require_once 'libs/score/scorelibrary.php';

# Enable Error Reporting and Display:

$jsonSongsEncoded = $_POST["tags"];

session_start();
$userid = $_SESSION['iduser'];

if (strlen($jsonSongsEncoded) > 0) {

    $jsonSongs = json_decode($jsonSongsEncoded);
    $conn = getCon();

    $uploaded = 0;
    $songid = $jsonSongs->idfile;
    $isNew = 0;
    if($jsonSongs->id == -1){
        $isNew = 1;
    }

    $id = treatSong($jsonSongs, $conn, $userid, $uploaded,
        $songAuthorArray, $songGenresArray, $valid, $imageSongDestination, $tmpDestinationSong);

    if ($uploaded) {
        if($isNew){
            updateScore("audioUpload","increase");
        }
        $id = $jsonSongs->id;
        $diskid = $jsonSongs->disk;
        $engDate = $jsonSongs->date;
        unset($jsonSongs);
        $jsonSongs->id = $id;
        $jsonSongs->date = $engDate;
        $url = '';

        if ($diskid == 'new') {

            foreach (glob($imageSongDestination . '' . $userid . '_' . $id . '.*') as $filename) {
                $url = $filename;
                break;
            }

        } else {

            foreach (glob($imageDiskDestination . '' . $userid . '_' . $diskid . '.*') as $filename) {
                $url = $filename;
                break;
            }
        }
        $jsonSongs->url = $url;


    }
    $jsonSongs->uploaded = $uploaded;


    echo json_encode($jsonSongs);
    mysqli_close($conn);
} else {
    echo '0ERROR: check post_max_size in php.ini and restart the web server and max_file_uploads';
}


function treatSong(&$jsonSongs, &$conn, &$userid, &$uploaded,
                   &$songAuthorArray, &$songGenresArray, &$valid, &$imageSongDestination, &$tmpDestination)
{


    $realSongId = intval($jsonSongs->id);

    $engDate = $jsonSongs->date;


    if (strlen($engDate) == 0)//change to current date
        $date = getdate(time());
    else {
        $day = intval(substr($engDate, 8, 2));
        $month = intval(substr($engDate, 5, 2));
        $year = intval(substr($engDate, 0, 4));

        if (!checkdate($month, $day, $year)) {//change to current date
            $date = getdate(time());
        } else {
            $date = getdate(strtotime($engDate));
        }

    }
    $yyyy = $date['year'];
    $mm = $date['mon'];
    $dd = $date['mday'];
    if (strlen($mm) == 1)
        $mm = '0' . $mm;
    if (strlen($dd) == 1)
        $dd = '0' . $dd;
    $jsonSongs->date = $yyyy . '-' . $mm . '-' . $dd;
    $engDate = $jsonSongs->date;


    $songname = $jsonSongs->name;
    $songAuthorArray = explode(',', $jsonSongs->aut);

    $songGenresArray = explode(',', $jsonSongs->gen);
    $license = $jsonSongs->license;
    if ($license < 0 || $license > 5) {
        $license = 0;
    }


    if ($conn->more_results())
        $conn->next_result();

    global $tmpDestinationSongFile;
    $songpath = $tmpDestinationSongFile . $userid . '_' . $jsonSongs->idfile;
    $path = getFile($tmpDestinationSongFile . $userid . '_' . $jsonSongs->idfile);

    if (!is_null($path)) {//with binary: new song or updating song

        $songFileType = pathinfo($path, PATHINFO_EXTENSION);

        if ($stmt = $conn->prepare('call addOrUpdateSong(?,?,?,?,?,?,?)')) {

            $songData = file_get_contents($path);

            $stmt->bind_param("ssssiii", $songname, $songData, $engDate, $songFileType, $realSongId, $userid, $license);

            // Execute the statement.
            $stmt->execute();


            // Get the variables from the query.
            $stmt->bind_result($uploaded, $realSongId);

            // Fetch the data.
            $stmt->fetch();


            $stmt->close();
        }

        if ($uploaded == 2) {
            $uploaded = 0;
            $jsonSongs->error0 = 'Songname cannot be repeated';
        }else if($uploaded){
            deleteFilePath($songpath);
        }
        $jsonSongs->id = $realSongId;

    } else {
        //$jsonSongs->error = 'Error uploading file';

        if ($stmt = $conn->prepare('call updateSongWithoutBinary(?,?,?,?,?)')) {


            $stmt->bind_param("ssiii", $songname, $engDate, $realSongId, $userid, $license);

            // Execute the statement.
            $stmt->execute();


            // Get the variables from the query.
            $stmt->bind_result($uploaded, $realSongId);

            // Fetch the data.
            $stmt->fetch();

            $stmt->close();
        }

    }
    if ($uploaded) {

        if ($jsonSongs->disk == 'new') {


            $songnamefilesystem = $tmpDestination . $userid . '_' . $jsonSongs->idfile;
            $current = $imageSongDestination . $userid . '_' . $realSongId;
            $f = getFile($songnamefilesystem);
            deleteFilePath($current);
            if (!is_null($f)) {
                $ext = pathinfo($f, PATHINFO_EXTENSION);

                rename($songnamefilesystem . '.' . $ext, $current . '.' . $ext);


                if ($stmt = $conn->prepare('call deleteDiskImage(?)')) {


                    $stmt->bind_param("i", $realSongId);

                    // Execute the statement.
                    $stmt->execute();


                    $stmt->close();
                }
            }

        } else {

            if ($stmt = $conn->prepare('call updateSongDiskimage(?,?,?)')) {

                $diskid = intval($jsonSongs->disk);
                $stmt->bind_param("iii", $realSongId, $diskid, $userid);

                // Execute the statement.
                $stmt->execute();


                // Get the variables from the query.
                $stmt->bind_result($uploaded);

                // Fetch the data.
                $stmt->fetch();

                $stmt->close();
            }
            if ($uploaded)
                deleteImage($imageSongDestination, $userid, $realSongId);
        }

    }


    $canModify = false;
    if ($uploaded) {


        $valid = true;


        $useridsong = -1;


        if ($stmt = $conn->prepare('call getAuthorsIDSong(?)')) {


            $stmt->bind_param("i", $realSongId);
            // Execute the statement.
            $stmt->execute();
            // Get the variables from the query.
            $stmt->bind_result($useridsong);

            // Fetch the data.
            while ($carregat = $stmt->fetch()) {

                if ($useridsong == $userid) {
                    $canModify = true;
                    break;
                }

            }


            $stmt->close();

        }
    }


    if ($canModify) {

        $conn->autocommit(false);
        $conn->begin_transaction();
        if ($conn->more_results())
            $conn->next_result();
        if ($stmt = $conn->prepare('call deleteAuthorsPuntuation(?)')) {


            $stmt->bind_param("i", $realSongId);
            // Execute the statement.
            $stmt->execute();


            $stmt->close();

        }
        if ($conn->more_results())
            $conn->next_result();
        if ($stmt = $conn->prepare('call deleteAuthorsAndGenresOfSong(?)')) {


            $stmt->bind_param("i", $realSongId);
            // Execute the statement.
            $stmt->execute();


            $stmt->close();

        }
        for ($i = 0; $i < count($songAuthorArray) && $uploaded; $i++) {

            $authorid = -1;
            if ($stmt = $conn->prepare('call addSongAuthorRelation(?,?,?)')) {

                $songAuthorArray[$i] = trim($songAuthorArray[$i]);
                $stmt->bind_param("sii", $songAuthorArray[$i], $realSongId, $userid);
                // Execute the statement.
                $stmt->execute();
                // Get the variables from the query.
                $stmt->bind_result($uploaded,$authorid);
                // Fetch the data.
                $stmt->fetch();

                $stmt->close();
            }
            if ($conn->more_results())
                $conn->next_result();
            if ($stmt = $conn->prepare('call addAuthorPuntuation(?,?)')) {


                $stmt->bind_param("ii", $realSongId,$authorid);
                // Execute the statement.
                $stmt->execute();


                $stmt->close();

            }


        }
        for ($i = 0; $i < count($songGenresArray) && $uploaded; $i++) {

            if ($stmt = $conn->prepare('call addSongGenreRelation(?,?,?)')) {

                $songGenresArray[$i] = trim($songGenresArray[$i]);
                $stmt->bind_param("sii", $songGenresArray[$i], $realSongId, $userid);
                // Execute the statement.
                $stmt->execute();
                // Get the variables from the query.
                $stmt->bind_result($uploaded);
                // Fetch the data.
                $stmt->fetch();

                $stmt->close();
            }


        }
        if (!$uploaded) {
            $conn->rollback();

        } else {

            $conn->commit();
            $conn->autocommit(true);
        }
    }
    return $realSongId;

}

